/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-23, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2001-04-05, Marcus Wolschon<Suran@gmx.net>)
  *       - supports devices
  * -------------------------------------------------------------------
  * TODO:
  */

package jaugment2.UI.java3dUI;

import java.util.Iterator;
import javax.media.j3d.BranchGroup;

/**
 * UI-factory for Java3D-representations of services
 */
public interface Java3DUIFactory
{
    /**
     * Convenience constant to use in the <CODE>toolkit</CODE>
     * field of <CODE>UIDescriptor</CODE>s that contain a
     * <CODE>JComponentFactory</CODE>.
     * The value of this constant is <CODE>"jaugment2.UI.textUI"</CODE>.
    */
    String TOOLKIT = "javax.media.j3d";

    /**
     * Convenience constant to use in the <CODE>UIFactoryTypes</CODE>
     * set in the <CODE>attributes</CODE> set of <CODE>UIDescriptor</CODE>s
     * that contain a <CODE>JComponentFactory</CODE>.
     * The value of this constant is <CODE>"jaugment2.UI.textUI.TextUIRepresentable.TextUIFactory"</CODE>.
    */
    String TYPE_NAME = "jaugment2.UI.java3dUI.Java3DUIFactory";

     /**
      * Returns a <CODE>BranchGroup</CODE>.
      */
     BranchGroup getRepresentation(Object roleObject);

     /**
      * Get aditional input-devices that may be needed
      * by the representation. They will be registred before
      * calling activateRepresentation and de-registred after removing the representation
      * from the scene. This method is allowed to return null if
      * no additional input-devices are used.
      */
     Iterator getInputDevices(BranchGroup bg);

     /**
      * This functiion will be called after getInputDevices
      * and does not need to do anything
      */
     void activateRepresentation(BranchGroup bg);
}