/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-12, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.UI.java3dUI;

import javax.swing.UIManager;
import java.awt.*;
import java.lang.reflect.Method;


/** A graphical Java3D-swing-UI and reference-implementation of a JAugment-UI
  */
public class Java3dUI
{
  boolean packFrame = false;

  //Construct the application
  public Java3dUI()
  {
   try
     {
      // workaround for a bug in the Linux-JComm-implementation
      // at a later time getPortIdentifier will fail if it has not been invoked here first
      Class c = Class.forName("javax.comm.CommPortIdentifier");
      if(c != null)
         {
          Method m = c.getDeclaredMethod("getPortIdentifier",new Class[]{String.class});
          if(m != null)
            m.invoke(null, new Object[]{"/dev/ttyS0"});
         }
//      javax.comm.CommPortIdentifier.getPortIdentifier("/dev/ttyS0");
      // ---------------
     }
   catch(Exception e)
     {
      e.printStackTrace(jaugment2.helpers.Logger.err);
     }


   System.err.println("Java3DUI-1");
     Java3dUIMainFrame frame = new Java3dUIMainFrame();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
//    if (packFrame)
//      frame.pack();
//    else
      frame.validate();
    //Center the window
   System.err.println("Java3DUI-2");
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
   System.err.println("Java3DUI-3");
  }

  //Main method
  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
    new Java3dUI();
  }
}
