/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-12, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2000-12-13, Marcus Wolschon<Suran@gmx.net>)
  *       - processes and deliveres keyboard-events
  *       - uses Window2D
  * 0.0.3 (2000-12-14, Marcus Wolschon<Suran@gmx.net>)
  *       - more cleanup
  *       - quite some code-reuse from SwingUI
  *       - first test representing a service
  *       - uses a UIManagerBean
  *       - represents all service found
  *       - dockins work without resizinge
  *       - testcode (not working) for aranging services in 3D-space
  *       - testcode (not working) for navigation in 3D-space
  * 0.0.4 (2000-12-21, Marcus Wolschon<Suran@gmx.net>)
  *       - aranging services works
  *       - moving the applications really works
  *       - KeyBehavior for navigation
  * 0.0.5 (2000-12-22, Marcus Wolschon<Suran@gmx.net>)
  *       - redraws windows after text-events
  * 0.0.6 (2000-12-23, Marcus Wolschon<Suran@gmx.net>)
  *       - uses Window2DExamineViewBehavior
  *       - cleaned up a bit
  *       - supports Java3DUIFactory
  * 0.0.7 (2001-01-10, Marcus Wolschon<Suran@gmx.net>)
  *       - testcode background
  * 0.0.8 (2001-01-11, Marcus Wolschon<Suran@gmx.net>)
  *       - RemoteBackground
  * 0.0.9 (2001-04-05, Marcus Wolschon<Suran@gmx.net>)
  *       - supports input-devices
  * -------------------------------------------------------------------
  * TODO:
  *       - implementation of RemoteBackground for augmented-vision, admin-panel for choosing backround
  *       - write aranging services in 3d-space (
  *          arange services by location-attributes into rooms (location has room),
  *          LOCATIONS ARE BOUNDING-BOXES that are given to windows and windows have a setBounds(...)-method to be invoked whenever they are moved out of/into an location
  *          create rooms where nesessary and
  *          allow placing some initial rooms by config-file)
  *          make the avatar a service that can be found by other UIs and provides chat (integrate telephone too)
  *       - write administring services (an administer-window with a special frame or head to be easily recognized)
  *       - write removing the BranchGroups
  *       - test sound
  *       - wrikte something to make menues work
  */
package jaugment2.UI.java3dUI;


import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
import javax.swing.event.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.LinkedList;
import java.rmi.RemoteException;
  //Java3D
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.picking.PickCanvas;
import com.sun.j3d.utils.picking.PickIntersection;
import com.sun.j3d.utils.picking.behaviors.PickRotateBehavior;
import com.sun.j3d.utils.behaviors.keyboard.KeyNavigatorBehavior;
import javax.media.j3d.*;
import javax.media.j3d.AmbientLight;
import javax.media.j3d.PointLight;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Canvas3D;
import javax.vecmath.*;
import javax.vecmath.Point3d;
  //JINI
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.core.lease.Lease;
import net.jini.lease.LeaseRenewalManager;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.UnknownEventException;
  //serviceui-draft-standart
import net.jini.core.entry.Entry;
import net.jini.lookup.ui.factory.JComponentFactory;
import net.jini.lookup.ui.factory.PanelFactory;
import net.jini.lookup.ui.attribute.UIFactoryTypes;
import net.jini.lookup.ui.attribute.RequiredPackages;
import net.jini.lookup.entry.UIDescriptor;
import net.jini.lookup.entry.Name;
import net.jini.admin.Administrable;
  //project
 import jaugment2.UI.UIManager.UIManagerBean;
import jaugment2.UI.UIManager.UIManagerEventListener;
import jaugment2.UI.UIManager.UIManagerEventEvent;
//import jaugment2.UI.UIManager.UIManagerBean.Instanciator;
import jaugment2.UI.textUI.TextUIRepresentable.TextUIFactory;
import jaugment2.UI.textUI.TextUIRepresentable.TextUIFactory;
import jaugment2.UI.textUI.TextUIRepresentable;
import jaugment2.UI.textUI.TextUI.ProcessAdaptor;
import jaugment2.helpers.Logger;
import jaugment2.UI.swingUI.MyTabbedPane;
import jaugment2.UI.swingUI.TextUIApaptorPanel;
import jaugment2.UI.swingUI.SwingUIRepresentable;



import jaugment2.UI.java3dUI.window2D.Window2DExamineViewerBehavior;
import jaugment2.UI.java3dUI.window2D.WindowGeometry;
import jaugment2.UI.java3dUI.window2D.Window2D;

/**
 * A 3-dimensional jAugment-UI capable of representing 2D- and text- representations too.
 */
public class Java3dUIMainFrame extends JFrame
{
  private static final boolean debugThis = false;
  /**
   * Our universe
   */
   SimpleUniverse u = null;

  /**
   * The canvas to draw on
   */
  Canvas3D canvas;


  /**
   * Out friend and helper
   */
  private UIManagerBean uiManagerBean;

  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel jPanel1 = new JPanel();

  JPanel dockinpane = new JPanel();

  public Java3dUIMainFrame()
  {
   enableEvents(AWTEvent.WINDOW_EVENT_MASK);

     // this is needed for applications using popup-menues
   JPopupMenu.setDefaultLightWeightPopupEnabled(false);

   try
     {
         // initialize 2D-part
      jbInit();

        // create the platform with the camera
      ViewingPlatform  viewingPlatform = new ViewingPlatform(1);
        // make it movable
                       viewingPlatform.getMultiTransformGroup().getTransformGroup(0).setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        // atach a new new
      Viewer  viewer = new Viewer(canvas, null);
        // create a new universe
      u = new SimpleUniverse(viewingPlatform, viewer/*canvas*/);


      u.getViewingPlatform().setNominalViewingTransform();
/*          // move 5 meters up
      Transform3D trans = new Transform3D();
      u.getViewingPlatform().getViewPlatformTransform().getTransform(trans);
      trans.setTranslation(new Vector3f(2.0f , 0.0f , -5.0f));
      u.getViewingPlatform().getViewPlatformTransform().getTransform(trans);*/

        //simple Keyboard-navigation
      KeyNavigatorBehavior nav = new KeyNavigatorBehavior(u.getViewingPlatform().getViewPlatformTransform());
      nav.setSchedulingBounds(new BoundingSphere(new Point3d(), 10000.0));
      BranchGroup bg = new BranchGroup();
      bg.addChild(nav);
      u.addBranchGraph(bg);

        // let there be light
      PointLight ambient = new PointLight();//new AmbientLight ambient = new AmbientLight();
      BranchGroup bg2 = new BranchGroup();
      bg2.addChild(ambient);
      u.addBranchGraph(bg2);


      try
        {
         // initialize jAugment-code and accept applications
         this.uiManagerBean = new UIManagerBean(new ServiceTemplate(null, null, null), // look for every service out there
                                                listener
                                               );
        }
      catch(Exception e)
        {
         e.printStackTrace(Logger.err);
        }


      //----------- testcode background
/*      Thread t = new Thread()
      {
       public void run()
       {*/
      try //JMF-code for this exists but is not in the public distribution. Ask the author for it or wait until it is stable.
        {
/*         Thread.currentThread().sleep(10000);
*/
         String bgclassname = null;//"jaugment2.UI.java3dUI.video.VideoBackground"; //TODO: allow user to choose one, allow bg's to be found as proxy-interfaces
         bgclassname = System.getProperty("jaugment2.UI.java3dUI.Java3dUIMainFrame.bgclass");

         if(bgclassname != null)
           {
            RemoteBackground vbg    = (RemoteBackground)Class.forName(bgclassname).newInstance();

              // force all components to be laid-out so canvas has a size
            this.validateTree();
            Background     bground  = vbg.getBackground(canvas);
            BranchGroup    bgbranch = new BranchGroup();
                           bgbranch.addChild(bground);
            bgbranch.compile();

            u.addBranchGraph(bgbranch);

            vbg.start();

            Thread.currentThread().sleep(1000);

            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] background-thread done");
           }
        }
      catch(Exception e)
        {
         e.printStackTrace(Logger.err);
        }
/*     };};
       t.setDaemon(true);
       t.start();*/
      //-----------


     }
   catch(Exception e)
    {
     Logger.err.println("ERROR: [Java3dUIMainFrame::Java3dUIMainFrame()] "+e.getLocalizedMessage());
     e.printStackTrace(Logger.err);
    }
  }








  /**
   * initialize the 2D-part of the UI
   */
  private void jbInit() throws Exception
  {
   this.getContentPane().setLayout(borderLayout1);
   this.setSize(new Dimension(400, 300));
   this.setTitle("Jaugment II");
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosed(WindowEvent e)
      {
        this_windowClosed(e);
      }
    });

   System.err.println("Java3dUIMainFrame -0");




    jPanel1.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        jPanel1_mouseClicked(e);
      }
    });


    jScrollPane1.setMaximumSize(new Dimension(22, 22));
    jScrollPane1.setPreferredSize(new Dimension(22, 22));
    this.getContentPane().add(jScrollPane1, BorderLayout.NORTH);
    jScrollPane1.getViewport().add(jPanel1, null);

    String temp = System.getProperty("jaugment2.UI.swingUI.SwingUIMainFrame.dockinposition");
    if(temp == null)
      {
       temp = BorderLayout.SOUTH;
       dockpanelIsVertival = false;
      }
    else
      {
       dockpanelIsVertival = temp.equals(BorderLayout.EAST) || temp.equals(BorderLayout.WEST);
      }

    this.getContentPane().add(dockinpane, BorderLayout.SOUTH/*temp*/);

    GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
    canvas = new Canvas3D(config);
    this.getContentPane().add(canvas, BorderLayout.CENTER);
    canvas.addKeyListener(new java.awt.event.KeyAdapter()
     {
       public void keyTyped(KeyEvent e)
       {
         c_keyTyped(e);
       }
       public void keyPressed(KeyEvent e)
       {
         c_keyTyped(e);
       }
       public void keyReleased(KeyEvent e)
       {
         c_keyTyped(e);
       }
     });
     canvas.addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
     {
       public void mouseMoved(MouseEvent e)
       {
         canvas_mouseMoved(e);
       }
     });



  }

  /**
   * debug-only
   */
  void jPanel1_mouseClicked(MouseEvent e)
  {
    System.out.println(">>mouse clicked at: "+e.getX()+" : "+e.getY());
  }

  /**
   * Someone typed a key in the canvas -> send it to the control with the keyboard-focus
   */
  void c_keyTyped(KeyEvent e)
  {
   if(Window2DExamineViewerBehavior.focus_c != null)
     {
      if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] c_keyTyped to a \""+Window2DExamineViewerBehavior.focus_c.getClass().getName()+"\" e.getKeyChar()=\""+e.getKeyChar()+"\" e.getID()="+e.getID());
        // dispatch event
      Window2DExamineViewerBehavior.focus_c.dispatchEvent(e);

        // debug
      if(debugThis)
      if(Window2DExamineViewerBehavior.focus_c instanceof JTextArea)
         Logger.debug.println("DEBUG: [Java3dUIMainFrame] text="+((JTextArea)Window2DExamineViewerBehavior.focus_c).getText());

           // redraw texture
      if(Window2DExamineViewerBehavior.focus_b != null)
        Window2DExamineViewerBehavior.focus_b.updateGraphics();
     }
   else
     {
      if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] no target for a c_keyTyped");
     }
  }


  //---------------------- look&feel -----------------------------------------------

 /**
  * Add the menu-enties for administrating a new service
  */
 private void addAdminEntry(ServiceItem item)
 {
  if(item.service instanceof Administrable)
    {
     AppEntry entry = (AppEntry)apps.get(item);
     JMenuItem mi = new JMenuItem(entry.name);
//TODO     mi.addActionListener(new MKListener(item, entry));
     entry.setAdminMenu(mi);
//TODO     jMenu_apps.add(mi);
    }
 }

 /**
  * Remove the menu-enties for administrating a new service
  */
 private void removeAdminEntry(ServiceItem item)
 {
  AppEntry entry = (AppEntry)apps.get(item);
  if(entry != null)
    {
//TODO     if(entry.admin_menu != null)
//TODO       jMenu_apps.remove(entry.admin_menu);
//TODO     if(entry.adminPanel != null)
//TODO       jTabbedPane1.remove(entry.adminPanel);
    }
 }

  //---------------------- Application-Management -----------------------------------------------

  /**
   * A new application is found, react to it
   * (get a name and usable representations)
   * @see TryUIDescriptor
   */
  private boolean newApp(ServiceItem app, boolean bringToTop)
  {
   if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] newApp");

   if(tryProcess(app.service, app))
    return(true);
   String name = "???";


       if(app.attributeSets != null)
          {

            // find a name
          for(int i=0; i<app.attributeSets.length; i++)
             {
              Entry o = app.attributeSets[i];
              if(o instanceof Name)
                {
                 Name n = (Name)o;
                 name = n.name;
                }
             }

           // find a UIDescriptor

           for(int i=0; i<app.attributeSets.length; i++)
             {
              if(tryUIDescriptor(((ServiceItem)app).attributeSets[i], app, name))
              return(true);
             }
          }


   if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] leaving newApp");
   apps.put(app, new AppEntry(app, null, null, name, new LinkedList()));
   addAdminEntry(app);
   return(false);
  }


  /**
   * maps ServiceItem to AppEntry
   */
  private Hashtable apps = new Hashtable();

  /**
   * Class for entries it the apps-hashtable
   */
  public static class AppEntry
  {
   public ServiceItem item;
   public String name;
   public JMenuItem admin_menu = null;
   public BranchGroup object;
   public Component adminPanel = null;
   public Component panel = null;
   public LinkedList inputdevices;

   public AppEntry(ServiceItem item, BranchGroup object, Component panel, String name, LinkedList inputdevices)
   {
    this.item = item;
    this.object = object;
    this.panel = panel;
    this.name = name;
    this.inputdevices = inputdevices;
   }

   public void setAdminMenu(JMenuItem admin_menu)
   {
    this.admin_menu = admin_menu;
   }

  }

  /**
   * Add a new AppEntry to our virtual world and store it
   */
  private void addAppEntry(Component c, ServiceItem item, String name)
  {
      // if it's a dock-in (see SwingUI for dockins)
   if((c instanceof JComponent) && (((JComponent)c).getMaximumSize().getHeight()<40) && (((JComponent)c).getMaximumSize().getWidth()<60) )  //TODO: size configurable
     {
      if(debugThis)Logger.debug.println("DEBUG: [Java3DUIMainFrame ] addAppEntry() adding dockin");
      dockinpane.add(c); //TODO: Test: support dockins
/*      if(dockpanelIsVertival)
        {
         double h = dockinpane.getPreferredSize().getSize().getHeight();
         if( h< ((JComponent)c).getMaximumSize().getHeight() )
            h = ((JComponent)c).getMaximumSize().getHeight();
         dockinpane.setMinimumSize(new Dimension(this.getWidth(), (int)h));
         dockinpane.setPreferredSize(new Dimension(this.getWidth(), (int)h));
         dockinpane.setMaximumSize(new Dimension(this.getWidth(), (int)h));
         }
       else
         {
          double w = dockinpane.getPreferredSize().getSize().getWidth();
          if( w< ((JComponent)c).getMaximumSize().getWidth() )
            w = ((JComponent)c).getMaximumSize().getWidth();
          dockinpane.setMinimumSize(new Dimension((int)w, this.getHeight()));
          dockinpane.setPreferredSize(new Dimension((int)w, this.getHeight()));
          dockinpane.setMaximumSize(new Dimension((int)w, this.getHeight()));
          this.invalidate();
         }*/

       apps.put(item, new AppEntry(item, null, c, name, new LinkedList()));
       addAdminEntry(item);
      }
    else
      {
       if(debugThis)Logger.debug.println("DEBUG: [Java3DUIMainFrame ] addAppEntry() adding app");
       //jScrollPane1.getViewport().add(c, null);
       JPanel p = new JPanel();
       p.setLayout(new BorderLayout());
       p.setMinimumSize(new Dimension(500, 500));
       p.setSize(new Dimension(500, 500));
       p.setMaximumSize(new Dimension(500, 500));
       p.add(c, BorderLayout.CENTER);
       jPanel1.add(p, null);
       Thread t = new AddWindowThread(c, item, name);
       t.setDaemon(true);
       t.start();
      }
  }

  /**
   * Thread to asyncronously add a Component to 3D-space while it is laid-out in 2D
   */
  private class AddWindowThread extends Thread
  {
   Component comp;
   ServiceItem item;
   String name;
   public AddWindowThread(Component comp, ServiceItem item, String name)
   {
    this.comp = comp;
    this.item = item;
    this.name = name;
   }
   public void run()
   {

     // wait until the component is laid-out
    for(int i=0; i<15; i++)
      {
       if(comp.getSize().getHeight()==0)
         try{sleep(100);}catch(Exception e){}
      }

    if(debugThis)Logger.debug.println("DEBUG: [Java3DUIMainFrame ] TestThread() adding app apps.size()="+apps.size());

      // create the Window (= adapter to use 2D-widgets in 3D-space)
    Window2D appwindow = new Window2D(comp, canvas);
    Transform3D pos = new Transform3D();
    synchronized(apps)
      {
         // arange the windows 1 meter apart (they are 1 meter in diameter) and at a distance of 6 meters
       pos.setTranslation(new Vector3f(2.0f*apps.size()-7.0f, 0.0f , -6.0f));
//       pos.transform(new Point3f(0.0f, 10.0f*apps.size(), 0.0f));
       appwindow.transform3D(pos);
         // add it to our universe
       u.addBranchGraph(appwindow);
         // store it
       apps.put(item, new AppEntry(item, appwindow, comp, name, new LinkedList()));
      }
    addAdminEntry(item);
   }
  };

  /**
   * We need to store this for resizing that panel the right way
   * when new elements arrive
   */
  private boolean dockpanelIsVertival = true;

  /**
   * Try to find a representation for the service using a serviceui-draft-standart UIDescriptor
   */
  private boolean tryUIDescriptor(Object o, ServiceItem item, String name)
  {
   try
     {
      if(o instanceof UIDescriptor)
        {
         Component c = null;

         UIDescriptor uid = (UIDescriptor)o;
         Object factory = uid.factory.get();//TODO: use MarshalledOPbject.isAsignableForm

         if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] factory is of class: "+factory.getClass().toString());

         if(factory instanceof Java3DUIFactory)
           { //TODO: test this
            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] adding BranchGroup");
            Java3DUIFactory fac = (Java3DUIFactory)factory;
            BranchGroup bg = fac.getRepresentation(item);

            if(bg==null)
              return(false);

            LinkedList inputdevices = new LinkedList();

            java.util.Iterator iter = fac.getInputDevices(bg);
            if(iter != null)
            while(iter.hasNext())
              {
               Object o2 = iter.next();
               if(o2 != null)
               if(o2 instanceof InputDevice)
                 {
                  u.getViewer().getPhysicalEnvironment().addInputDevice((InputDevice)o2);
                  inputdevices.add(o2);
                 }
               else
                 {
                  Logger.warning.println("WARNING! [Java3dUIMainFrame] service's Java3DUIFactory returned a list of input-devices of which one is no input-device but ["+o.getClass().toString()+"]");
                 }
              }

            fac.activateRepresentation(bg);

            Transform3D pos = new Transform3D();
            synchronized(apps)
              {
                 // arange the windows 1 meter apart (they are 1 meter in diameter) and at a distance of 6 meters
               pos.setTranslation(new Vector3f(2.0f*apps.size()-7.0f, 0.0f , -6.0f));

                 // create a TransformGroup and translate the bg to it's initial position
               TransformGroup objTrans = new TransformGroup();
        //   objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE | TransformGroup.ALLOW_TRANSFORM_READ | Group.ALLOW_CHILDREN_EXTEND);
               objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
               objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
               objTrans.setCapability(Group.ALLOW_CHILDREN_EXTEND);
               objTrans.addChild(bg);
               objTrans.setTransform(pos);

                 // this wrapper will wrap the tg for AppEntry
               BranchGroup wrapper = new BranchGroup();
               wrapper.addChild(objTrans);

                  // add it to our universe
               u.addBranchGraph(wrapper);
                  // store it
               apps.put(item, new AppEntry(item, wrapper, null, name, inputdevices));
              };
            addAdminEntry(item);
            return(true);
           }
         else
         if(factory instanceof JComponentFactory)
           {
            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] adding JComponent");
             c =  ((JComponentFactory)factory).getJComponent(item);
           }
         else
         if(factory instanceof PanelFactory)
           {
            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] adding Panel");
            c = ((PanelFactory)factory).getPanel(item);
           }
         else
         if(factory instanceof TextUIFactory)
           {
            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] adding TextUIApaptorPanel");
            c = new TextUIApaptorPanel(((TextUIFactory)factory).getRepresentation(item));
           }
         else
           {
            if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:tryUIDescriptor()] cannot use this UIDescriptor");
            return(false);
           }


         addAppEntry(c, item, name);
         return(true);
        }

     }
   catch(Exception e)
     {
      Logger.err.println("ERROR: [Java3dUIMainFrame:tryUIDescriptor()] could not accept application because of: "+e.getMessage()+" ["+e.getClass().toString()+"]");
      e.printStackTrace(Logger.err);
     }

   return(false);
  }

  /**
   * Try to represent an  Object o, if it is a Process
   */
  private boolean tryProcess(Object o, ServiceItem item)
  {
   try
     {
      if(o instanceof Process)
        {
         SwingUIRepresentable uid = new TextUIApaptorPanel(new ProcessAdaptor((Process)o));
         if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] newApp - using old SwingUIRepresentable");
         Component c =  uid.getPanel();
//TODO         jTabbedPane1.addTab("???", c);

         addAppEntry(c, item, "???");
         return(true);
        }

     }
   catch(Exception e)
     {
      Logger.err.println("could not accept application because of: "+e.getMessage()+" ["+e.getClass().toString()+"]");
     }

   return(false);
  }

  private void lostApp(ServiceItem app)
  {
   try
     {
      if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] lostApp(...)");
      AppEntry entry = (AppEntry)apps.get(app);
      if(entry != null)
        {
         removeAdminEntry(app);
         if(entry.panel != null)
           dockinpane.remove(entry.panel);
         if(entry.object != null)
           {
//TODO           Window2D win = (Windowe2D)entry.object;
//TODO           u.???
           };
         for(int i=0; i<entry.inputdevices.size(); i++)
            u.getViewer().getPhysicalEnvironment().removeInputDevice((InputDevice)entry.inputdevices.get(i));
        }
      }
   catch(Exception e)
      {
       Logger.err.println("could not remove application because of: "+e.getMessage()+" ["+e.getClass().toString()+"]");
      }
  }



  /** react to events from out UIManagerBean
    */
  private UIManagerEventListener listener = new UIManagerEventListener()
  {
   public void localProcessStarted(UIManagerEventEvent e)
   {
    if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame:listener] localProcessStarted");

    newApp(new ServiceItem(null, e.proc, new Entry[] {}), true);

   }

   public void ApplicationFound(UIManagerEventEvent e)
   {
    if(e.item != null)
      {
       if(e.item instanceof ServiceItem)
         {
          Java3dUIMainFrame.this.newApp((ServiceItem)e.item, false);
         }

      }


   }

   public void ApplicationVanished(UIManagerEventEvent e)
   {
    if(e.item != null)
      {
       if(e.item instanceof ServiceItem)
         {
          Java3dUIMainFrame.this.lostApp((ServiceItem)e.item);
         }
      }
   }

  };


  private int lastmousex = -1;
  private int lastmousey = -1;

  void canvas_mouseMoved(MouseEvent e)
  {
/*   try
     {
      if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] mouseMoved ["+(e.getX()-lastmousex)+":"+(e.getY()-lastmousey)+"]");

      if(lastmousex==-1)
      if(lastmousey==-1)
        {
         lastmousex = e.getX();
         lastmousey = e.getY();
         return;
        }

      Transform3D trans = new Transform3D();
      u.getViewingPlatform().getMultiTransformGroup().getTransformGroup(0).getTransform(trans);
      trans.setTranslation(new Vector3f(0.01f*(e.getX()-lastmousex), 0.01f*(e.getY()-lastmousey), 0.0f));
     u.getViewingPlatform().getMultiTransformGroup().getTransformGroup(0).setTransform(trans);




      lastmousex = e.getX();
      lastmousey = e.getY();

     }
   catch(Exception ex)
     {
      ex.printStackTrace(Logger.err);
     }*/
  }

  void this_windowClosed(WindowEvent e)
  {
   if(debugThis)Logger.debug.println("DEBUG: [Java3dUIMainFrame] this_windowClosed(...)");
   if(debugThis)Logger.debug.flush();
   Enumeration enum = apps.elements();
   while(enum.hasMoreElements())
     {
      AppEntry aw =(AppEntry)enum.nextElement();
      lostApp(aw.item);
     }
  }


}
