/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-01-11, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.UI.java3dUI;

  //JDK
import java.rmi.Remote;
import java.rmi.RemoteException;
  //Java3D
import javax.media.j3d.Background;

/**
 * Factory providing a background for the 3D-UI
 */
public interface RemoteBackground extends Remote
{

  /**
   * @param c the component that will be rendered to primarily (does not need to be a Canvas3D).
   */
  public Background getBackground(java.awt.Component c) throws RemoteException;

  /**
   * start is called after getBackground at a time the javax.media.j3d.Background
   * is integrated into the scene and may be compiled.
   */
  public void start() throws RemoteException;
}