/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-23, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2000-12-24, Marcus Wolschon<Suran@gmx.net>)
  *       - special handling for combo-boxes
  * 0.0.3 (2001-04-08, Marcus Wolschon<Suran@gmx.net>)
  *       - -"- works
  * -------------------------------------------------------------------
  * TODO:
  *       - change the key-bindings
  *       - somehow making mouse-events out of collisions does not work
  *       - as deasigned yet
  */
package jaugment2.UI.java3dUI.window2D;



  //JDK
import java.awt.*;
import java.awt.event.*;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JComboBox;
import java.util.*;
import java.awt.image.*;
import java.lang.reflect.Array;

import javax.media.j3d.*;
import javax.media.j3d.Behavior;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.WakeupOnCollisionEntry;
import javax.media.j3d.WakeupOnCollisionMovement;
import javax.media.j3d.WakeupOnCollisionExit;
import javax.media.j3d.Bounds;
import javax.media.j3d.BoundingBox;
import javax.media.j3d.PickCone;
import javax.vecmath.*;
import javax.vecmath.Vector3d;
import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.image.TextureLoader;
  //project
import jaugment2.helpers.Logger;
import jaugment2.UI.java3dUI.runeMagic.AutomataBehavior;



public class Window2DExamineViewerBehavior extends AutomataBehavior//ViewerBehavior
{
  private static final boolean debugThis = true;

 private static JPopupMenu myPopupMenu = null;

 /* Previous cursor location
 */
 protected int previousX = 0;
 /* Previous cursor location
 */
 protected int previousY = 0;

 /* Saved standard cursor
  */
 protected Cursor savedCursor = null;

//-------------------- von ViewerBehavior

	// Keep track of the transform group who's transform we modify
	// during mouse motion.
	protected TransformGroup subjectTransformGroup = null;

	// Keep a set of wakeup criterion for different mouse-generated
	// event types.
	protected WakeupCriterion[] mouseEvents = null;
	protected WakeupOr mouseCriterion = null;

	// Track which button was last pressed
	protected static final int BUTTONNONE = -1;
	protected static final int BUTTON1 = 0;
	protected static final int BUTTON2 = 1;
	protected static final int BUTTON3 = 2;
	protected int buttonPressed = BUTTONNONE;

	// Keep a few Transform3Ds for use during event processing.  This
	// avoids having to allocate new ones on each event.
	protected Transform3D currentTransform = new Transform3D( );
	protected Transform3D transform1 = new Transform3D( );
	protected Transform3D transform2 = new Transform3D( );
	protected Matrix4d matrix = new Matrix4d( );
	protected Vector3d origin = new Vector3d( 0.0, 0.0, 0.0 );
	protected Vector3d translate = new Vector3d( 0.0, 0.0, 0.0 );

	// Unusual X and Y delta limits.
	protected static final int UNUSUAL_XDELTA = 400;
	protected static final int UNUSUAL_YDELTA = 400;

	protected Component parentComponent = null;


	/**
	 * Default X and Y rotation factors, and XYZ translation factors.
	 */
	public static final double DEFAULT_XROTATION_FACTOR = 0.02;
	public static final double DEFAULT_YROTATION_FACTOR = 0.005;
	public static final double DEFAULT_XTRANSLATION_FACTOR = 0.02;
	public static final double DEFAULT_YTRANSLATION_FACTOR = 0.02;
	public static final double DEFAULT_ZTRANSLATION_FACTOR = 0.04;

	protected double XRotationFactor    = DEFAULT_XROTATION_FACTOR;
	protected double YRotationFactor    = DEFAULT_YROTATION_FACTOR;
	protected double XTranslationFactor = DEFAULT_XTRANSLATION_FACTOR;
	protected double YTranslationFactor = DEFAULT_YTRANSLATION_FACTOR;
	protected double ZTranslationFactor = DEFAULT_ZTRANSLATION_FACTOR;

//--------------------

  BranchGroup test;
///  private Shape3D pickShape3D;
  private Matrix3f mouseMatrix;

  /**
   * only for test-purposes
   */
//  public Window2DExamineViewerBehavior()
 public Window2DExamineViewerBehavior( BranchGroup bg, TransformGroup transformGroup, Canvas3D parent, Component ctl, Appearance app , BranchGroup pickShape3DBG)
 {
  super(null);
  mouseMatrix = Window2D.getMouseTransformMatrix();
//  super( parent );

  init_check(pickShape3DBG/*bg*/, parent);
  subjectTransformGroup = transformGroup;
  this.ctl = ctl;
  this.app = app;
  this.parent = parent;
//----debug
  this.test = bg;
/*  test.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
  test.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
*/
  this.setCapability(Behavior.ALLOW_BOUNDS_READ);
//----/debug

   String what = "";
   try
     {
      what = "creating State";
      State s = new State(new Transition[0]);
      what = "creating getAWTEvent";
       StimulusPushValueAction a0 = new StimulusPushValueAction(new Object[0], Class.forName("javax.media.j3d.WakeupOnAWTEvent").getMethod("getAWTEvent", new Class[0]));
//       StackInvokeAction       a1 = new StackInvokeAction(true, 0, Class.forName("java.awt.event.MouseEvent").getMethod("getX", new Class[0]));
//       StackInvokeAction       a2 = new StackInvokeAction(true, 0, Class.forName("java.awt.event.MouseEvent").getMethod("getY", new Class[0]));
//       StackInvokeAction       a3 = new StackInvokeAction(true, 0, Class.forName("java.awt.event.MouseEvent").getMethod("getClickCount", new Class[0]));
//       StackInvokeAction       a4 = new StackInvokeAction(false, 0, Class.forName("java.awt.AWTEvent").getMethod("getID", new Class[0]));

      what = "creating dragged-action";
       Action actions_dragged[] = new Action[] {
          a0/*, a1, a2,a3, a4*/ //TODO: invoke reaction
          , new PopInvokeAction(this, 1, this.getClass().getMethod("processAWTEvents", new Class[] {Array.newInstance(Class.forName("java.awt.AWTEvent"),0).getClass()}))
         };
      Transition mouseTrans0 = new Transition(s, new WakeupOnAWTEvent( java.awt.event.MouseEvent.MOUSE_DRAGGED ), new ListAction(actions_dragged));
      s.addTransition(mouseTrans0);

      what = "creating pressed-action";
       Action actions_pressed[] = new Action[] {
          a0/*, a1, a2,a3, a4*/ //TODO: invoke reaction
          , new PopInvokeAction(this, 1, this.getClass().getMethod("processAWTEvents", new Class[] {Array.newInstance(Class.forName("java.awt.AWTEvent"),0).getClass()}))
         };
      Transition mouseTrans1 = new Transition(s, new WakeupOnAWTEvent( java.awt.event.MouseEvent.MOUSE_PRESSED ), new ListAction(actions_pressed));
      s.addTransition(mouseTrans1);

      what = "creating released-action";
       Action actions_released[] = new Action[] {
          a0/*, a1, a2,a3, a4*/ //TODO: invoke reaction
          , new PopInvokeAction(this, 1, this.getClass().getMethod("processAWTEvents", new Class[] {Array.newInstance(Class.forName("java.awt.AWTEvent"),0).getClass()}))
         };
      Transition mouseTrans2 = new Transition(s, new WakeupOnAWTEvent( java.awt.event.MouseEvent.MOUSE_RELEASED ), new ListAction(actions_released));
      s.addTransition(mouseTrans2);

      what = "creating WakeupOnCollisionEntry";
      Action actions_collision[] = new Action[] {
//          new StimulusDebugAction(),
//          new DebugAction("-WakeupOnCollisionEntry-"),
                   // push a new Point3d on top of it
          new PushValueAction(new Object[]{new Point3d()}),
                   // push TriggeringBounds onto the stack
          new StimulusPushValueAction(new Object[0], WakeupOnCollisionEntry.class.getMethod("getTriggeringBounds", new Class[0])),
                  // set it to the lower position by invoking "getLower" on the TriggeringBounds
          new StackInvokeAction(false, true, 1, BoundingBox.class.getMethod("getLower", new Class[] {Point3d.class})),
                  // invoke processTouch with the position
          new PopInvokeAction(this, 1, this.getClass().getMethod("processTouch", new Class[] {Point3d.class}))
         };
      Transition collisionTrans = new Transition(s, new WakeupOnCollisionEntry(bg, WakeupOnCollisionEntry.USE_GEOMETRY ), new ListAction(actions_collision));
      s.addTransition(collisionTrans);

/*      what = "creating WakeupOnCollisionMovement";
      Action actions_collisionm[] = new Action[] {
//          new StimulusDebugAction(),
//          new DebugAction("-WakeupOnCollisionMovement-"),
                   // push a new Point3d on top of it
          new PushValueAction(new Object[]{new Point3d()}),
                   // push TriggeringBounds onto the stack
          new StimulusPushValueAction(new Object[0], WakeupOnCollisionMovement.class.getMethod("getTriggeringBounds", new Class[0])),
                  // set it to the lower position by invoking "getLower" on the TriggeringBounds
          new StackInvokeAction(false, true, 1, BoundingBox.class.getMethod("getLower", new Class[] {Point3d.class})),
                  // invoke processTouch with the position
          new PopInvokeAction(this, 1, this.getClass().getMethod("processTouchDrag", new Class[] {Point3d.class}))
         };
      Transition collisionTransm = new Transition(s, new WakeupOnCollisionMovement(bg, WakeupOnCollisionMovement.USE_GEOMETRY ), new ListAction(actions_collisionm));
      s.addTransition(collisionTransm);
*/
      what = "creating WakeupOnCollisionExit";
      Action actions_collisionX[] = new Action[] {
//          new StimulusDebugAction(),
          new DebugAction("-WakeupOnCollisionExit-"),
                   // push a new Point3d on top of it
          new PushValueAction(new Object[]{new Point3d()}),
                   // push TriggeringBounds onto the stack
          new StimulusPushValueAction(new Object[0], WakeupOnCollisionExit.class.getMethod("getTriggeringBounds", new Class[0])),
                  // set it to the lower position by invoking "getLower" on the TriggeringBounds
          new StackInvokeAction(false, true, 1, BoundingBox.class.getMethod("getLower", new Class[] {Point3d.class})),
                  // invoke processTouch with the position
          new PopInvokeAction(this, 1, this.getClass().getMethod("processTouchStop", new Class[] {Point3d.class}))
         };
      Transition collisionTransX = new Transition(s, new WakeupOnCollisionExit(bg, WakeupOnCollisionExit.USE_GEOMETRY ), new ListAction(actions_collisionX));
      s.addTransition(collisionTransX);

      what = "creating automata";
      this.setAutomata(new Automata(new State[]{s}, s));
     }
   catch(Exception e)
     {
      Logger.err.println("ERROR: of type ["+e.getClass().toString()+"] while "+what);
      e.printStackTrace(Logger.err);
     }
  }



 /**
  * Construct an examine behavior that listens to mouse movement
  * and button presses to generate rotation and translation
  * transforms written into the given transform group as well as
  * transforming and relaying mouse-presses of the first-button
  * to a control (with an aprropriate coordinate-transformation).
  *
  * @param bg the branch-group whose elements must be hit
  * to not ignore the event (so multiple of this behaviors can
  * act independently)
  *
  * @param transformGroup The transform group to be modified
  * by the behavior.
  *
  * @param parent The Canvas3D that contains the area
  * generating mouse events.
  *
  * @param ctl the control to relay first-mouse-button-clicks to
  *
  * @param app the apearance whos texture is to be updated after
  * first-mouse-button-clicks to reflect the look of parameter ctl
  */
/* public Window2DExamineViewerBehavior( BranchGroup bg, TransformGroup transformGroup, Canvas3D parent, Component ctl, Appearance app )
 {
  super( parent );
  init_check(bg, parent);
  subjectTransformGroup = transformGroup;
  this.ctl = ctl;
  this.app = app;
  this.parent = parent;
 }*/

 Canvas3D parent = null;

 public void processAWTEvents( AWTEvent me2[] )
 {
  for(int i=0; i<me2.length;i++)
  if(me2[i] instanceof MouseEvent)
    processMouseEvent((MouseEvent)me2[i]);
 }

 public void processTouch(Point3d pos)
 {
  try
    {
     Transform3D thistrans= new Transform3D();
     this.subjectTransformGroup.getTransform(thistrans);
     Matrix4d m4d = new Matrix4d();
     thistrans.get(m4d);
     m4d.transform(pos);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouch("+pos+") this.getBounds()="+this.getBounds()+" intersects="+(this.getBounds()==null?"":(this.getBounds().intersect(pos)?"true":"false")));

/*
     BranchGroup node = new BranchGroup();
     node.addChild(new com.sun.j3d.utils.geometry.ColorCube());
     TransformGroup tg = new TransformGroup();
     Transform3D trans= new Transform3D();
     Transform3D thistrans= new Transform3D();
     this.subjectTransformGroup.getTransform(thistrans);
//     thistrans.invert();
//     trans.set(thistrans);
     trans.setTranslation(new Vector3d(pos.x, pos.y, pos.z));
     tg.setTransform(trans);
     node.addChild(tg);
     tg.addChild(new com.sun.j3d.utils.geometry.ColorCube());

     test.addChild(node);
*/

     Point2d pix = new  Point2d();
     parent.getPixelLocationFromImagePlate(pos, pix);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouch() pix="+pix);

     MouseEvent me = new MouseEvent(parent,
                                    MouseEvent.MOUSE_PRESSED,
                                    System.currentTimeMillis(),
                                    MouseEvent.BUTTON1_MASK,
                                    parent.getHeight()-(int)pix.x,
                                    (int)pix.y,
                                    1,
                                    false);
     processMouseEvent(me);
    }
  catch(Exception e)
    {
     e.printStackTrace();
    }
 }

 public void processTouchDrag(Point3d pos)
 {
  try
    {
     Transform3D thistrans= new Transform3D();
     this.subjectTransformGroup.getTransform(thistrans);
     Matrix4d m4d = new Matrix4d();
     thistrans.get(m4d);
     m4d.transform(pos);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouchDrag("+pos+")");

     Point2d pix = new  Point2d();
     parent.getPixelLocationFromImagePlate(pos, pix);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouch() pix="+pix);

     MouseEvent me = new MouseEvent(parent,
                                    MouseEvent.MOUSE_DRAGGED,
                                    System.currentTimeMillis(),
                                    MouseEvent.BUTTON1_MASK,
                                    parent.getHeight()-(int)pix.x,
                                    (int)pix.y,
                                    1,
                                    false);
     processMouseEvent(me);
    }
  catch(Exception e)
    {
     e.printStackTrace();
    }
 }

 public void processTouchStop(Point3d pos)
 {

  try
    {
     Transform3D thistrans= new Transform3D();
     this.subjectTransformGroup.getTransform(thistrans);
     Matrix4d m4d = new Matrix4d();
     thistrans.get(m4d);
     m4d.transform(pos);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouchStop("+pos+")");

     Point2d pix = new  Point2d();
     parent.getPixelLocationFromImagePlate(pos, pix);
     if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processTouch() pix="+pix);

     MouseEvent me = new MouseEvent(parent,
                                    MouseEvent.MOUSE_RELEASED,
                                    System.currentTimeMillis(),
                                    MouseEvent.BUTTON1_MASK,
                                    parent.getHeight()-(int)pix.x,
                                    (int)pix.y,
                                    1,
                                    false);
     processMouseEvent(me);

     //TODO: if not dragged too far
     MouseEvent me2 = new MouseEvent(parent,
                                    MouseEvent.MOUSE_CLICKED,
                                    System.currentTimeMillis(),
                                    MouseEvent.BUTTON1_MASK,
                                    parent.getHeight()-(int)pix.x,
                                    (int)pix.y,
                                    1,
                                    false);
     processMouseEvent(me2);
    }
  catch(Exception e)
    {
     e.printStackTrace();
    }
 }

 public void processMouseEvent( MouseEvent me2 )
 {
  if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] processMouseEvent ID="+me2.getID()+" modifiers="+me2.getModifiers()+" InputEvent.BUTTON2_MASK="+InputEvent.BUTTON2_MASK+" if2="+(( ( me2.getModifiers() & InputEvent.BUTTON2_MASK) != 0)?"true":"false"));
  if( ( me2.getModifiers() & InputEvent.BUTTON1_MASK) != 0)
  if( ( me2.getModifiers() & InputEvent.BUTTON2_MASK) != 0)
    {
     onButton3(me2);
     return;
    }

  if( ( me2.getModifiers() & InputEvent.BUTTON1_MASK) != 0)
    onButton1(me2);
  if( ( me2.getModifiers() & InputEvent.BUTTON2_MASK) != 0)
    onButton2(me2);
  if( ( me2.getModifiers() & InputEvent.BUTTON3_MASK) != 0)
    onButton3(me2);
 }


 /**
  * Respond to a button1 event (press, release, or drag).
  *
  * @param mouseEvent A MouseEvent to respond to.
  */
 public void onButton1( MouseEvent /*mev*/me2 )
 {


            int pos[] = getClickPosition( me2 );
            if(pos == null)
              return; // our object is not hit

            int _x = pos[0];
            int _y = pos[1];



	     if(debugThis)Logger.debug.println ("denormalized Coordinates of intersection pt: "+_x+" : "+_y);

             Component ctl2       = ctl;
             Component parent_ctl = ctl;
             boolean changed = true;

             while(changed)
               {
                ctl2 = parent_ctl.getComponentAt(_x, _y);
                if(ctl2==null)
                  {
                   Logger.err.println ("ERROR: [Window3DBehavior] no combonent at "+_x+" : "+_y);
                   ctl2 = ctl.locate(_x, _y);
                   if(ctl2==null)
                      Logger.err.println ("ERROR: [Window3DBehavior] not within combonent at "+_x+" : "+_y);
                  }

                else
                  {
                   if(debugThis)Logger.debug.println("DEBUG: [Window3DBehavior] ctl at "+_x+" : "+_y+" is a ["+ctl2.getClass().getName()+"]");
                  }


                if(ctl2 != null)
                  {
                   focus_c = ctl2;
                   focus_b = this;
                   _x = _x- ctl2.getX();
                   _y = _y- ctl2.getY();
                   changed = (ctl2 != parent_ctl);
                   parent_ctl = ctl2;
                  if(ctl2 instanceof JComboBox)
                    changed = false;
                  }
                else
                  {
                   ctl2 = ctl;
                   changed = false;
                  }
               }

             if(ctl2 instanceof JComboBox)
               {

//                if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] special jComboBox-handling");
                //special handling as menu-elements do not work
                if(myPopupMenu == null)
                  {
                   JPopupMenu.setDefaultLightWeightPopupEnabled(false);
                   myPopupMenu = new JPopupMenu();
                  }
                else
                  {
                   if(!myPopupMenu.isShowing())
                      myPopupMenu.removeAll();
                  }
                if(myPopupMenu.isShowing())
                  {
                   if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] special jComboBox-handling - still showing");
                  }
                else
                  {
                   JComboBox combo = (JComboBox)ctl2;
                   for(int i=0; i<combo.getItemCount(); i++)
                     {
                      Object item = combo.getItemAt(i);
                      JMenuItem mi = new JMenuItem(item.toString());
                      mi.addActionListener(new PopupMenuActionListener(combo, item));
                      myPopupMenu.add(mi);
                     }
                   myPopupMenu.show(parent.getParent(), me2.getX(), me2.getY());
                   if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] special jComboBox-handling parent.getLocationOnScreen()="+parent.getLocationOnScreen()+" m.getComponentCount()"+myPopupMenu.getComponentCount());
                  }
               }
             else
               {

               MouseEvent me = new MouseEvent( ctl2/* me2.getComponent()*/, me2.getID(), me2.getWhen(), me2.getModifiers(),
                                              _x, _y ,
//                                               me2.getX(), me2.getY(),
                                               me2.getClickCount(), me2.isPopupTrigger());

//               if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] message-ID="+me.getID());
               ctl2.dispatchEvent(me);

                 // we do not get mouse-clicked so we need to send them ourselve
               if(me.getID()==MouseEvent.MOUSE_RELEASED)
                 {
                  if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] got a  mouseReleased - sending a mouseClicked");
                  me = new MouseEvent( ctl2/* me2.getComponent()*/, MouseEvent.MOUSE_CLICKED, me2.getWhen(), me2.getModifiers(),
                                              _x, _y ,
//                                               me2.getX(), me2.getY(),
                                               me2.getClickCount(), me2.isPopupTrigger());

                  ctl2.dispatchEvent(me);
                 }

              }

/*                // leave a mark where we clicked
                Graphics  g =  ctl.getGraphics();
                g.setColor(Color.black);
                g.fillRect(_x,_y,14,14);*/

               // update the texture
               //TODO: make this faster
//----

/*            if(ctl.getWidth()>0 && ctl.getHeight()>0)
              {
               ctl.setSize(100, 100);
              }*/

            updateGraphics();
/*            if(ctl.getWidth()>0 && ctl.getHeight()>0)
              {
               BufferedImage img = new BufferedImage(ctl.getWidth(), ctl.getHeight(), BufferedImage.TYPE_INT_RGB);
               Graphics ctlg = img.getGraphics();
               ctl.paintAll(ctlg);
               ctlg.drawLine(0,0, 59, 25);
               ctlg.drawLine(0, 25, 59, 0);
               Texture txt = (new TextureLoader(img)).getTexture();
               app.setTexture(txt);
              }
            else
              {
               Logger.warning.println("WARNING: [Window2DBehavior] control has size 0");
              }*/
//----
            Logger.err.println("WARNING: [Window2DBehavior] done");

	}

    private class PopupMenuActionListener implements java.awt.event.ActionListener
    {
      JComboBox combo;
      Object item;
      public PopupMenuActionListener(JComboBox combo, Object item)
      {
       this.combo = combo;
       this.item  = item;
      }

      public void actionPerformed(ActionEvent e)
      {
       combo.setSelectedItem(item);
       updateGraphics();
      }
    };



	/**
	 * Respond to a button2 event (press, release, or drag).
	 *
	 * @param mouseEvent A MouseEvent to respond to.
	 */
	public void onButton2( MouseEvent mev )
	{
		if ( subjectTransformGroup == null )
			return;

		int x = mev.getX( );
		int y = mev.getY( );
         if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] onButton2() ID="+mev.getID()+", x="+x+", y="+y+"");
//TODO: TEST: if we hit one of the _our_ small boxen
 if(!check(x, y))
   return;

		if ( mev.getID( ) == MouseEvent.MOUSE_PRESSED )
		{
			// Mouse button pressed:  record position
			previousX = x;
			previousY = y;

			// Change to a "move" cursor
			if ( parentComponent != null )
			{
				savedCursor = parentComponent.getCursor( );
				parentComponent.setCursor(
					Cursor.getPredefinedCursor( Cursor.MOVE_CURSOR ) );
			}
			return;
		}
		if( mev.getID( ) == MouseEvent.MOUSE_RELEASED )
		  {
			// Mouse button released:  do nothing

			// Switch the cursor back
			if ( parentComponent != null )
				parentComponent.setCursor( savedCursor );
                   if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] onButton2() MOUSE_RELEASED previousX="+previousX+", x="+x+", previousY="+previousY+", y="+y+"");

                   if(previousX == x)
                   if(previousY == y)
                     {
                      if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] onButton2() we did not move, handling this as a click...");
                      onButton1(mev); // we did not move, send a click
                     }
                   return;
		  }

		//
		// Mouse moved while button down:  create a translation
		//
		// Compute the delta in Y from the previous
		// position.  Use the delta to compute translation
		// distances with the mapping:
		//
		//   positive Y mouse delta --> positive Y-axis translation
		//
		// where positive X mouse movement is to the right, and
		// positive Y mouse movement is **down** the screen.
		//
		int deltaY = y - previousY;

		if ( deltaY > UNUSUAL_YDELTA || deltaY < -UNUSUAL_YDELTA )
		{
			// Deltas are too huge to be believable.  Probably a glitch.
			// Don't record the new XY location, or do anything.
			return;
		}

		double zTranslationDistance = deltaY * ZTranslationFactor;

		//
		// Build transforms
		//
		translate.set( 0.0, 0.0, zTranslationDistance );
		transform1.set( translate );

		// Get and save the current transform
		subjectTransformGroup.getTransform( currentTransform );

		// Translate as needed
		currentTransform.mul( transform1, currentTransform );

		// Update the transform group
		subjectTransformGroup.setTransform( currentTransform );

		previousX = x;
		previousY = y;
	}


	/**
	 * Respond to a button3 event (press, release, or drag).
	 *
	 * @param mouseEvent A MouseEvent to respond to.
	 */
	public void onButton3( MouseEvent mev )
	{
		if ( subjectTransformGroup == null )
			return;

		int x = mev.getX( );
		int y = mev.getY( );

//TODO: TEST: if we hit one of the _our_ small boxen
 if(!check(x, y))
   return;

		if ( mev.getID( ) == MouseEvent.MOUSE_PRESSED )
		{
			// Mouse button pressed:  record position
			previousX = x;
			previousY = y;

			// Change to a "move" cursor
			if ( parentComponent != null )
			{
				savedCursor = parentComponent.getCursor( );
				parentComponent.setCursor(
					Cursor.getPredefinedCursor( Cursor.MOVE_CURSOR ) );
			}
			return;
		}
		if ( mev.getID( ) == MouseEvent.MOUSE_RELEASED )
		{
			// Mouse button released:  do nothing

			// Switch the cursor back
			if ( parentComponent != null )
				parentComponent.setCursor( savedCursor );

                   if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] onButton3() MOUSE_RELEASED previousX="+previousX+", x="+x+", previousY="+previousY+", y="+y+"");

                   if(previousX == x)
                   if(previousY == y)
                     {
                      if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] onButton3() we did not move, handling this as a click...");
                      onButton1(mev); // we did not move, send a click
                     }

			return;
		}

		//
		// Mouse moved while button down:  create a translation
		//
		// Compute the delta in X and Y from the previous
		// position.  Use the delta to compute translation
		// distances with the mapping:
		//
		//   positive X mouse delta --> positive X-axis translation
		//   positive Y mouse delta --> negative Y-axis translation
		//
		// where positive X mouse movement is to the right, and
		// positive Y mouse movement is **down** the screen.
		//
		int deltaX = x - previousX;
		int deltaY = y - previousY;

		if ( deltaX > UNUSUAL_XDELTA || deltaX < -UNUSUAL_XDELTA ||
			deltaY > UNUSUAL_YDELTA || deltaY < -UNUSUAL_YDELTA )
		{
			// Deltas are too huge to be believable.  Probably a glitch.
			// Don't record the new XY location, or do anything.
			return;
		}

		double xTranslationDistance = deltaX * XTranslationFactor;
		double yTranslationDistance = -deltaY * YTranslationFactor;

		//
		// Build transforms
		//
		translate.set( xTranslationDistance, yTranslationDistance, 0.0 );
		transform1.set( translate );

		// Get and save the current transform
		subjectTransformGroup.getTransform( currentTransform );

		// Translate as needed
		currentTransform.mul( transform1, currentTransform );

		// Update the transform group
		subjectTransformGroup.setTransform( currentTransform );

		previousX = x;
		previousY = y;
	}


	/**
	 * Respond to an elapsed frames event (assuming subclass has set up a
	 * wakeup criterion for it).
	 *
	 * @param time A WakeupOnElapsedFrames criterion to respond to.
	 */
	public void onElapsedFrames( WakeupOnElapsedFrames timeEvent )
	{
		// Can't happen
	}

 private PickCanvas pickCanvas = null;
  PickResult[] pickResult;
  /**
   * The component we process and translate the mouse-events for
   */
  private Component ctl;

  /**
   * The apearance to render the texture with the view of the component into
   */
  private Appearance app;

  /**
   * The component, that has the keyboard-focus
   */
  public static Component focus_c = null;
  /**
   * The behavior for the component, that has the keyboard-focus
   */
  public static Window2DExamineViewerBehavior focus_b = null;

 private void init_check(BranchGroup branchGroup, Canvas3D canvas3D)
 {
   pickCanvas = new PickCanvas(canvas3D, branchGroup);
   pickCanvas.setTolerance(5.0f);
   pickCanvas.setMode(PickCanvas.GEOMETRY);
 }

 /**
  * Check if our geometry was picked
  */
 private boolean check(int x, int y)
 {
//  Logger.debug.println("DEBUG: [ExamineViewBehavior] check(x="+x+", y="+y+")");
  pickCanvas.setShapeLocation(x, y);
 // PickResult pr[] = pickCanvas.pickAllSorted();
   PickResult pr = pickCanvas.pickClosest();
  if(debugThis)Logger.debug.println("DEBUG: [ExamineViewBehavior] check(x="+x+", y="+y+") returning "+(pr != null));
  return(pr != null);
//  return(true);
 }


  private int[] getClickPosition(MouseEvent evt)
  {
//   Logger.err.println("WARNING: [Window2DBehavior] getClickPosition");
   if(debugThis)Logger.debug.println("DEBUG: [Window2DExamineViewerBehavior] getClickPosition("+evt+") x="+evt.getX()+" y="+evt.getY());
   int x = evt.getX();
   int y = evt.getY();
   pickCanvas.setShapeLocation(x, y);

   Point3d eyePos = pickCanvas.getStartPosition();
   pickResult = pickCanvas.pickAllSorted();//TODO: catch exception if we picked the small boxen and ignore the click
   if(pickResult == null)
     {
      Logger.err.println("WARNING: [Window2DBehavior] pickResult == null");
      return(null);
     }


   // Get closest intersection results
   PickIntersection pi = pickResult[0].getClosestIntersection(eyePos);

   GeometryArray curGeomArray = pi.getGeometryArray();

   // Position sphere at intersection point
   Vector3d v = new Vector3d();
   Point3d intPt = pi.getPointCoordinatesVW();

   Point3d []ptw = pi.getPrimitiveCoordinatesVW();
   Point3d []pt  = pi.getPrimitiveCoordinates();

   if(debugThis)System.out.println ("=============");
   if(debugThis)System.out.println ("Coordinates of intersection pt:"+intPt);
   if(debugThis)System.out.println ("Coordinates of vertices: ");

   double minx = Double.MAX_VALUE;
   double miny = Double.MAX_VALUE;
   double maxx = Double.MIN_VALUE;
   double maxy = Double.MIN_VALUE;

   for(int k=0;k<pt.length;k++)
      {
       System.out.println (k + ":" + ptw[k].x + " " + ptw[k].y + " " + ptw[k].z);
       if(ptw[k].x<minx)
          minx = ptw[k].x;
       if(ptw[k].y<miny)
          miny = ptw[k].y;
       if(ptw[k].x>maxx)
          maxx = ptw[k].x;
       if(ptw[k].y>maxy)
          maxy = ptw[k].y;
      }

   double normalx = (intPt.x-minx)/(maxx-minx);
   double normaly = (intPt.y-miny)/(maxy-miny);
   if(debugThis)Logger.debug.println ("normalized Coordinates of intersection pt: "+normalx+" : "+normaly+" max=["+maxx+":"+maxy+"], min=["+minx+":"+miny+"]");

   if(ctl==null)
     {
      Logger.err.println("ERROR: [Window2DBehavior] ctl==null");
      return(null);
     }

//---- test
   if(mouseMatrix != null)
     {
      if(debugThis)Logger.debug.println ("getMouseTransformMatrix != null");
   /*new Matrix3f(-1.0f, 0.0f, 1.0f,
                                0.0f, 1.0f, 0.0f,
                                0.0f, 0.0f, 1.0f
                              );*/
      Point3f t3f = new Point3f((float)normalx, (float)normaly, 1.0f);
      mouseMatrix.transform(t3f);
      float fa[] = new float[3];
      t3f.get(fa);
      normalx =fa[0];
      while(normalx<0.0) normalx = normalx+1.0;
      while(normaly<0.0) normaly = normaly+1.0;
      normaly =fa[1];
     }
//----

   int _x = (int)(ctl.getWidth()*normalx);//+ctl.getX();
   int _y = (int)(ctl.getHeight()*(1-normaly));//+ctl.getY();

   Point3d closestVert = pi.getClosestVertexCoordinatesVW();
   if(debugThis)Logger.debug.println ("Closest vertex: "+closestVert);


   return(new int[] {_x, _y});
  }


 /**
  * Recreate and draw the texture
  */
 public void updateGraphics()
 {
  if(ctl.getWidth()>0 && ctl.getHeight()>0)
    {
     BufferedImage img = new BufferedImage(ctl.getWidth(), ctl.getHeight(), BufferedImage.TYPE_INT_RGB);
     Graphics ctlg = img.getGraphics();
     ctl.paintAll(ctlg);
//     ctlg.drawLine(0,0, 59, 25);
//     ctlg.drawLine(0, 25, 59, 0);
     Texture txt = (new TextureLoader(img)).getTexture();
     app.setTexture(txt);
    }
  else
   {
    Logger.warning.println("WARNING: [Window2DBehavior] control has size 0");
   }

 }

}
