/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Java3D-UI
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-13, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2000-12-24, Marcus Wolschon<Suran@gmx.net>)
  *       - no color
  * -------------------------------------------------------------------
  * TODO:
  *       - make it flat
  */
package jaugment2.UI.java3dUI.window2D;
import javax.media.j3d.*;
import javax.vecmath.*;

public class WindowGeometry extends QuadArray
{

  public WindowGeometry()
  {
   super(24, GeometryArray.COORDINATES | GeometryArray.TEXTURE_COORDINATE_3 /*| GeometryArray.COLOR_3*/);

   Point3f verts[] = new Point3f[8];
//   Color3f colors[] = new Color3f[3];

    verts[0] = new Point3f(0.5f, 0.5f,  0.5f);
    verts[1] = new Point3f(-0.5f, 0.5f, 0.5f);
    verts[2] = new Point3f(-0.5f,-0.5f, 0.5f);
    verts[3] = new Point3f( 0.5f,-0.5f, 0.5f);
    verts[4] = new Point3f( 0.5f, 0.5f,-0.5f);
    verts[5] = new Point3f( -0.5f, 0.5f,-0.5f);
    verts[6] = new Point3f( -0.5f,-0.5f,-0.5f);
    verts[7] = new Point3f( 0.5f,-0.5f,-0.5f);

/*    colors[0] = new Color3f(1.0f, 0.0f, 0.0f);
    colors[1] = new Color3f(0.0f, 1.0f, 0.0f);
    colors[2] = new Color3f(0.0f, 0.0f, 1.0f);*/

    Point3f pnts[] = new Point3f[24];
//    Color3f clrs[] = new Color3f[24];
    Point2f txtc[] = new Point2f[24];

    for(int i=0; i<24; i+=4)
       {
        txtc[i+3] = new Point2f(1.0f, 0.0f);
        txtc[i+0] = new Point2f(1.0f, 1.0f);
        txtc[i+1] = new Point2f(0.0f, 1.0f);
        txtc[i+2] = new Point2f(0.0f, 0.0f);
       }

    pnts[0] = verts[0];
//    clrs[0] = colors[(int)(Math.random()*3.0)];
    pnts[1] = verts[3];
//    clrs[1] = colors[(int)(Math.random()*3.0)];
    pnts[2] = verts[7];
//    clrs[2] = colors[(int)(Math.random()*3.0)];
    pnts[3] = verts[4];
//    clrs[3] = colors[(int)(Math.random()*3.0)];

    pnts[4] = verts[1];
//    clrs[4] = colors[(int)(Math.random()*3.0)];
    pnts[5] = verts[5];
//    clrs[5] = colors[(int)(Math.random()*3.0)];
    pnts[6] = verts[6];
//    clrs[6] = colors[(int)(Math.random()*3.0)];
    pnts[7] = verts[2];
//    clrs[7] = colors[(int)(Math.random()*3.0)];

    pnts[8]  = verts[0];
//    clrs[8]  = colors[(int)(Math.random()*3.0)];
    pnts[9]  = verts[4];
//    clrs[9]  = colors[(int)(Math.random()*3.0)];
    pnts[10] = verts[5];
//    clrs[10] = colors[(int)(Math.random()*3.0)];
    pnts[11] = verts[1];
//    clrs[11] = colors[(int)(Math.random()*3.0)];

    pnts[12] = verts[3];
//    clrs[12] = colors[(int)(Math.random()*3.0)];
    pnts[13] = verts[2];
//    clrs[13] = colors[(int)(Math.random()*3.0)];
    pnts[14] = verts[6];
//    clrs[14] = colors[(int)(Math.random()*3.0)];
    pnts[15] = verts[7];
//    clrs[15] = colors[(int)(Math.random()*3.0)];

    pnts[16] = verts[0];
//    clrs[16] = colors[(int)(Math.random()*3.0)];
    pnts[17] = verts[1];
//    clrs[17] = colors[(int)(Math.random()*3.0)];
    pnts[18] = verts[2];
//    clrs[18] = colors[(int)(Math.random()*3.0)];
    pnts[19] = verts[3];
//    clrs[19] = colors[(int)(Math.random()*3.0)];

    pnts[20] = verts[7];
//    clrs[20] = colors[(int)(Math.random()*3.0)];
    pnts[21] = verts[6];
//    clrs[21] = colors[(int)(Math.random()*3.0)];
    pnts[22] = verts[5];
//    clrs[22] = colors[(int)(Math.random()*3.0)];
    pnts[23] = verts[4];
//    clrs[23] = colors[(int)(Math.random()*3.0)];


    setCoordinates(0, pnts);
    setTextureCoordinates(0, txtc);
    //setColors(0, clrs);
  }
}
