/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: default-keyboard-implementation
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-06-09, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.java3d.defaultkeyboard;

  //JDK
import java.rmi.RemoteException;
import java.rmi.Remote;
import java.rmi.MarshalledObject;
import java.util.StringTokenizer;
import java.util.LinkedList;
import java.util.Hashtable;
import java.util.Date;
import java.util.Enumeration;
import java.net.URL;
import java.net.InetAddress;
import java.lang.Runnable;
import java.lang.Process;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.LineNumberReader;
  //JINI
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.UnknownLeaseException;
import net.jini.core.lease.Lease;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.UnknownEventException;

import net.jini.core.entry.Entry;
import net.jini.core.discovery.LookupLocator;
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
  //project
import jaugment2.jini.simpleService.VerySimpleService;
import jaugment2.jini.SimpleLandlord;
import jaugment2.jini.SimpleLandlord.LeaseListener;
import jaugment2.jini.SimpleLandlord.EventRegistration;
import jaugment2.helpers.Logger;
import jaugment2.UI.java3dUI.Java3DUIFactory;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;

//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


/**
 * Service providing a pc104-like keyboard
 */
public class KeyboardService extends VerySimpleService implements jaugment2.java3d.defaultkeyboard.KeyboardServiceIF
{

  //--------------------- initiaslisation&administration ------------------------------------------------------//

  private static final boolean debugThis = false;

  public String getComment() {return("Service providing a pc104-like keyboard");};
  public String getCreator() {return("Marcus Wolschon <Suran@gmx.net>");};
  public UIDescriptor getUIDescriptor() {return(null/*KeyboardServiceJava3DRepresentation.getUIDescriptor()*/);}; //TODO


  public KeyboardService() throws RemoteException
  {
   if(debugThis)Logger.debug.println("DEBUG: [KeyboardService] creating myself...");
   try
     {
      this.init(this, jaugment2.java3d.defaultkeyboard.KeyboardServiceIF.class);
     }
   catch(Exception e)
     {
      e.printStackTrace(Logger.err);
     };
  };

  public KeyboardService(LookupLocator locallocator) throws RemoteException
  {
   if(debugThis)Logger.debug.println("DEBUG: [KeyboardService] creating myself...");
   try
     {
      this.init(this, jaugment2.java3d.defaultkeyboard.KeyboardServiceIF.class);
     }
   catch(Exception e)
     {
      e.printStackTrace(Logger.err);
     };
  };





 /** restart this service once it has been stopped
   * @see stop
   */
 public void restart() throws Exception
 {
 }


  private URL sceneURL = null;
  public java.net.URL getSceneURL() throws java.rmi.RemoteException
  {
   return(sceneURL);
  }

 /** stop this service. If exit is false all references to this
   * service are still valid but it has deregistered everywhere.
   * (this includes the RMI-activation-daemon)
   * @see restart
   * @see destroy
   * @param exit stop running
   */
 public void stop(boolean exit) throws Exception
 {
 }

 /** stop this service, destroy any persistent storage and exit
   */
 public void destroy() throws RemoteException
 {
  deinit();
 }
}