package jaugment2.java3d.hand;

  //Java
import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
  //Java3D
import javax.media.j3d.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class HandInputDevice implements InputDevice
{


 private Vector3f position = new Vector3f();
 private Transform3D newTransform = new Transform3D();
 Sensor sensors[] = new Sensor[1];
 public int getSensorCount()
 {
  return(this.sensors.length);
 }
 public Sensor getSensor(int sensorIdx )
 {
  return(this.sensors[sensorIdx]);
 }
 private HandInput handInput;

 private Vector3f initPos = new Vector3f();
 private Transform3D rotTransX = new Transform3D();
 private Transform3D rotTransY = new Transform3D();
 private Transform3D rotTransZ = new Transform3D();

 private int processingMode;
 public int getProcessingMode()
 {
  return(this.processingMode);
 }

 private SensorRead sensorRead = new SensorRead();

 public HandInputDevice()
 {
  handInput = new SerialHandInput();//VirtualHandInput();
  handInput.setDevice(this);

  initPos.set(0.0f, 0.0f, 0.0f);
  processingMode = InputDevice.DEMAND_DRIVEN;

  sensors[0] = new Sensor(this);
 }

 public void close()
 {
  handInput.close();
 }


 public boolean initialize()
 {
  return true;
 }

 public void pollAndProcessInput()
 {
  sensorRead.setTime( System.currentTimeMillis() );

/*  rotTransX.rotX(-handInput.getHandXAngle());
  rotTransY.rotY(-handInput.getHandYAngle());
  rotTransZ.rotZ(-handInput.getHandZAngle());
*/

  handInput.getHandPosition(position);
  newTransform.set(position);
/*  newTransform.mul(rotTransX );
  newTransform.mul(rotTransY);
  newTransform.mul(rotTransZ);
*/

  sensorRead.set(newTransform );
  sensors[0].setNextSensorRead(sensorRead );
 }


 public void processStreamInput()
 {
 }


 public void setNominalPositionAndOrientation()
 {
  sensorRead.setTime( System.currentTimeMillis() );

  rotTransX.rotX(0.0f);
  rotTransY.rotY(0.0f);
  rotTransZ.rotZ(0.0f);

  position.set(initPos);

  newTransform.set(position );

  newTransform.mul(rotTransX);
  newTransform.mul(rotTransY);
  newTransform.mul(rotTransZ);

  sensorRead.set(newTransform );
  sensors[0].setNextSensorRead( sensorRead );
  handInput.setHandPosition(initPos);
 }



 public void setProcessingMode( int mode )
 {
  switch(mode)
  {
   case InputDevice.DEMAND_DRIVEN:
   case InputDevice.NON_BLOCKING:
   case InputDevice.BLOCKING:
        {
         processingMode = mode;
         break;
        }
   default:
        {
         throw new IllegalArgumentException("Processing mode be DEMAND_DRIVEN, BLOCKING, or NON_BLOCKING");
        }
  }
 }

}
