/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: mirror
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-04-01, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * 0.0.2 (2001-04-05, Marcus Wolschon<Suran@gmx.net>)
  *       - uses proxy.getSceneURL()
  * -------------------------------------------------------------------
  * TODO:
  *       - get the URL of the scene to load
  */
package jaugment2.java3d.objectService;


  //Swing
import java.io.Serializable;
import java.io.IOException;
import java.rmi.MarshalledObject;
import java.rmi.RemoteException;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Set;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Map;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Iterator;
import java.awt.Color;
  //JINI
import net.jini.core.lookup.ServiceItem;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
import net.jini.lookup.ui.MainUI;
import net.jini.lookup.ui.attribute.UIFactoryTypes;
import net.jini.lookup.ui.attribute.RequiredPackages;
  //Java3D
import javax.media.j3d.BranchGroup;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.vrml97.VrmlLoader;
import com.sun.j3d.loaders.vrml97.VrmlScene;
import com.sun.j3d.loaders.vrml97.impl.MovieTexture;
import javax.media.j3d.QuadArray;
import javax.media.j3d.Appearance;
import javax.media.j3d.Shape3D;
import javax.media.j3d.GeometryArray;
import javax.media.j3d.Material;
import javax.media.j3d.RenderingAttributes;
import javax.media.j3d.ColorInterpolator;
import javax.media.j3d.Alpha;
import javax.media.j3d.RotationInterpolator;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Color3f;
import javax.vecmath.*;
  //project
import jaugment2.helpers.Logger;
import jaugment2.UI.java3dUI.Java3DUIFactory;



public class ObjectServiceJava3DRepresentation extends BranchGroup
{


 /**
  * Get a UIDescriptor as needed by the serviceui-draft-standart
  */
 public static UIDescriptor getUIDescriptor()
  {
   try
     {
      return(new UIDescriptor(MainUI.ROLE,
                              Java3DUIFactory.TOOLKIT,
                              getServiceUIProperties(),
                              new MarshalledObject(new Factory()))
                             );
     }
   catch(IOException e)
     {
      Logger.err.print(e.getLocalizedMessage());
      e.printStackTrace(Logger.err);
     }
   return(null);
  }

  /**
   * Gets a serviceui-draft-standart-compactible attribute-set of this representation
   */
  static Set getServiceUIProperties()
  {
   HashSet set = new HashSet();
   set.add("javax.media.j3d.BranchGroup");
   set.add("javax.media.j3d.Group");
   set.add("javax.media.j3d.Node");
   set.add("javax.media.j3d.SceneGraphObject");

   HashSet retval = new HashSet();
   retval.add(new UIFactoryTypes(set));

   HashMap map = new HashMap();
   map.put("javax.media.j3d", Package.getPackage("javax.media.j3d").getSpecificationVersion());
   RequiredPackages req = new RequiredPackages(map);
   retval.add(req);

   return(retval);
  }


  /**
   * A serializable factory for creating this UI
   */
  public static class Factory implements Java3DUIFactory, Serializable
  {

    /**
     * Returns a <CODE>BranchGroup</CODE>.
     */
    public BranchGroup getRepresentation(Object roleObject)
    {
     Logger.debug.println("DEBUG: [ObjectServiceJava3DRepresentation.factory] getRepresentation called");
     try
       {
        net.jini.core.lookup.ServiceItem item = (net.jini.core.lookup.ServiceItem)roleObject;
        return(new ObjectServiceJava3DRepresentation((ObjectServiceProxy)item.service));
       }
     catch(Exception e)
       {
        e.printStackTrace(Logger.err);
       }
     return(null);
    }

   public Iterator getInputDevices(BranchGroup bg)
   {return(null);};

   public void activateRepresentation(BranchGroup bg)
   {};




  }

 private static final boolean debutThis = false;

 public ObjectServiceJava3DRepresentation(ObjectServiceProxy proxy)
 {
  super();

   try
     {
      VrmlLoader loader = new VrmlLoader();
      Scene s = loader.load(proxy.getSceneURL()/*"World.wrl"*/);
      addChild(s.getSceneGroup());
      return;
     }
  catch(Exception e)
    {
     e.printStackTrace();
    }

 }

}