/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: mirror
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-04-01, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */
package jaugment2.java3d.objectService;

  //JDK
import java.rmi.server.UnicastRemoteObject;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
import java.io.Serializable;
import java.lang.IllegalStateException;
import java.util.Enumeration;
  //JINI
import net.jini.core.event.RemoteEventListener;
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.Lease;
import net.jini.admin.Administrable;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
  //project
import jaugment2.jini.simpleService.simpleAdministrator;
import jaugment2.jini.simpleService.SimpleRepresentedAdministrator;
import jaugment2.directory.Directory.*;
import jaugment2.directory.DirectoryServiceSwingAdministration;

//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


public class ObjectServiceProxy extends UnicastRemoteObject implements Administrable, Serializable, Remote
{

  private ObjectService service;

  public ObjectServiceProxy(ObjectService s) throws RemoteException
  {
   super(0,
         ((System.getProperty("jaugment2.java3d.objectService.ObjectServiceProxy.useSSL")!=null)?
            new jaugment2.rmi.SSLRMIClientSocketFactory("jaugment2.java3d.mirror.ObjectServiceProxy.sslserveropts"):null
         ),
         ((System.getProperty("jaugment2.java3d.objectService.ObjectServiceProxy.useSSL")!=null)?
            new jaugment2.rmi.SSLRMIServerSocketFactory("jaugment2.java3d.mirror.ObjectServiceProxy.sslserveropts"):null
         )
        );

   this.service = s;
  }

    /**
     * Returns an object that implements our administration-interfaces.
     *
     * @throws java.rmi.RemoteException
     * @see JoinAdmin
     */
  public Object getAdmin() throws RemoteException
  {
//   return(new SimpleRepresentedAdministrator(service, new UIDescriptor[] {DirectoryServiceSwingAdministration.getUIDescriptor()}));
//   return(new DirectoryServiceAdministrator(service));
   return(new simpleAdministrator(service));
  }



  public java.net.URL getSceneURL()
  {
   return(service.getSceneURL());
  }

}